package app;

import java.util.Arrays;

@SuppressWarnings("unchecked")
public class MyStack<E> {
    private E[] array;
    private int pointer = 0;

    public MyStack() {
        this.array = (E[]) new Object[1];
    }

    public void push(E el) {
        if (array.length == pointer)
            resizeArray(1);
        array[pointer++] = el;
    }

    public E pop() {
        pointer--;
        E ret = array[pointer];
        if (array.length >= pointer)
            resizeArray(0);
        return ret;
    }

    private void resizeArray(int factor) {
        E[] old = this.array.clone();
        this.array = (E[]) new Object[pointer + factor];
        int i = 0;
        for (E e : old)
            if (pointer + factor > i)
                this.array[i++] = e;
    }

    public boolean isEmpty() {
        return this.array.length == 0;
    }

    @Override
    public String toString() {
        return Arrays.toString(this.array);
    }

    public void reverse() {
        E[] old = this.array.clone();
        int ii = 0;
        for (int i = this.array.length - 1; i > -1; i--)
            this.array[i] = old[ii++];
    }
}